#include <iostream.h>
#include <cstring.h>
#include <classlib\arrays.h>
//    
typedef TIArrayAsVector<string> TContainer;
typedef TIArrayAsVectorIterator<string> TIterator;
//     
void ShowMe(const char *msg, TContainer &cr);

int main()
{
TContainer *cp;     //   
string s(""); //  

//       
cp = new TContainer(10, 0, 10);
cout << endl;
cout << "  : ";
if (cp->OwnsElements())
	 cout << "TRUE" << endl;
 else
	 cout << "FALSE" << endl;

//      
cp->Add(new string(""));
cp->Add(new string(""));
cp->Add(new string(""));
cp->Add(new string(""));
cp->Add(&s);     // !!'!!!  
ShowMe(" :", *cp);

//        
cp->Detach(2, TShouldDelete::Delete);
ShowMe(" : Detach(2, Delete)", *cp);

//    ,     
cp->Detach(&s, TShouldDelete::NoDelete);
ShowMe(" : Detach(&s, NoDelete)", *cp);

//    , ,  
int n = cp->GetItemsInContainer();
cp->Detach(n - 1, TShouldDelete::DefDelete);
ShowMe(" : Detacla(n - 1, DefDelete)", *cp);

//     , , ,  
cp->Flush();
ShowMe(": Flush()",*cp);

//  .    ???
delete cp;
return 0;
}


//    ,    
void ShowMe(const char *msg, TContainer &cr)
{
TIterator iterator(cr);                    //    
string *sp;	                               //    

cout << endl << msg << endl;	             //  
cout << "   = ";	    //  
cout << cr.GetItemsInContainer() << endl;  //   
while ((sp = iterator++)!= 0)	        		 //   
cout << " " << *sp;	             			 //  
cout << endl;	                  			 //  
}



